#ifndef _MBFONT_H_
#define _MBFONT_H_

#include "structs.h"
#include "ewmh.h"

#ifdef USE_PANGO
#define font_height(font) (((font).ascent) + ((font).descent))
#define font_ascent(font) ((font).ascent)
#define font_ref(font) (&(font))
#else
#define font_height(font) (((font)->ascent) + ((font)->descent))
#define font_ascent(font) ((font)->ascent)
#define font_ref(font) ((font))
#endif

#ifdef USE_PANGO
Bool
font_load (Wm                   *w, 
	   char                 *spec, 
	   MBPangoFont          *font);
#elif USE_XFT
Bool
font_load (Wm                   *w, 
	   char                 *spec, 
           XftFont              **font);
#else
Bool
font_load (Wm                   *w, 
	   char                 *spec, 
           XFontStruct          **font);
#endif

#ifdef USE_PANGO
void
font_paint (Wm                   *w, 
	    XftDraw              *drawable,
	    XftColor             *color,
	    MBPangoFont          *font,
	    PangoLayout          *pgo_layout,
	    unsigned char        *text,
	    int                   text_len,
	    int                   x,
	    int                   y);
#elif USE_XFT
void
font_paint (Wm                   *w, 
	    XftDraw              *drawable,
	    XftColor             *color,
	    XftFont              *font,
	    unsigned char        *text,
	    int                   text_len,
	    Bool                  text_is_utf8,
	    int                   x,
	    int                   y);
#else
void
font_paint (Wm                   *w, 
	    Drawable              drawable,
	    XColor               *color,
	    XFontStruct          *font,
	    GC                    gc,
	    unsigned char        *text,
	    int                   text_len,
	    int                   x,
	    int                   y);
#endif


#ifdef USE_PANGO
int
font_get_str_width (Wm                   *w, 
		    MBPangoFont          *font,
		    unsigned char        *text,
		    int                   text_len,
		    Bool                  text_is_utf8);
#elif USE_XFT
int
font_get_str_width (Wm                   *w, 
		    XftFont              *font,
		    unsigned char        *text,
		    int                   text_len,
		    Bool                  text_is_utf8);
#else
int
font_get_str_width (Wm                   *w, 
		    XFontStruct          *font,
		    unsigned char        *text,
		    int                   text_len,
		    Bool                  text_is_utf8);
#endif

#endif


